.nolist
include \masm32\include\masm32rt.inc

UseMMX	= 0
UseBsr	= 0

if UseMMX
	.xmm
endif

ShowQw 	PROTO: DWORD
ShowQwMMX 	PROTO: DWORD
ShowQwBsr	PROTO: DWORD

flexbyte$ MACRO ptrQword:REQ
  ifndef FlexByteBuffer
	.data?
	FlexByteBuffer	dd 4 dup (?)
	.code
  endif
  if UseMMX
	invoke ShowQwMMX, ptrQword
  elseif UseBsr
	invoke ShowQwBsr, ptrQword
  else
	invoke ShowQw, ptrQword
  endif
  EXITM <offset FlexByteBuffer>
ENDM

.data?
wfd	WIN32_FIND_DATA <?>
fSize	dq ?
fHandle	dd ?
buffer	db 260 dup (?)

.data
compl1024	REAL4 0.0009765625	; 1/1024
t6	db 9, "EB",0
t5	db 9, "PB",0
t4	db 9, "TB",0
t3	db 9, "GB",0
t2	db 9, "MB",0
t1	db 9, "kB",0
t0	db 9, "bytes",0

.code
start:	push ebx				; save counter
	; invoke FindFirstFile, chr$("\Masm32\*.*"), addr wfd
	invoke GetCurrentDirectory, 260, offset buffer
	invoke lstrcat, offset buffer, chr$("\*.*")
	invoke FindFirstFile, offset buffer, addr wfd

	mov fHandle, eax
	.While eax
		print chr$(13,10)
		mov ecx, offset fSize		; we need to store the file size elsewhere ...
		mov eax, wfd.nFileSizeHigh	; ... because stupidly enough, the wfd order...
		mov [ecx+4], eax
		mov eax, wfd.nFileSizeLow	; ... is wrong, so we have to invert it
		mov [ecx], eax

		print flexbyte$(ecx)			; format [ecx] nicely: ecx is a pointer to a QWORD

		print chr$(9)
		print addr wfd.cFileName
		invoke FindNextFile, fHandle, addr wfd
	.Endw
	invoke FindClose, fHandle

	if UseMMX
		emms	; if you need the FPU in your own program afterwards
		mov ebx, chr$("The size of the MMX flexbyte$ proc (bytes): ")
		mov ecx, dummyPMMX-ShowQwMMX
	elseif UseBsr
		mov ebx, chr$("The size of the Bsr flexbyte$ proc (bytes): ")
		mov ecx, dummyBsr-ShowQwBsr
	else
		mov ebx, chr$("The size of the standard flexbyte$ proc (bytes): ")
		mov ecx, dummyP-ShowQw
	endif
	if 1
		invoke MessageBox, 0, str$(ecx), ebx, MB_OK
	else
		push ecx
		print chr$(13,10,10)
		print ebx
		pop ecx
		print str$(ecx)
	endif
	print chr$(13, 10)
	pop ebx
	invoke ExitProcess, 0

if UseMMX
align 16
ShowQwMMX proc uses edi esi pNum:DWORD
  mov esi, pNum					; pointer to our 8-byte number
  movq mm0, qword ptr [esi]		; move the number into mm0
  movq mm1, mm0				; move a copy to mm1
  mov edi, 6						; we have 6 different units
  mov ecx, 1024*1024				; divisor
  movd mm2, ecx					; put the "divisor" into mm2, and let it start with 2^20

@@:	movq mm3, mm2			; use a copy of the divisor
	; psubq mm3, mm0			; subtract original number: no opcode
	db 0fh, 0fbh, 0d8h 			; in ML 6.14, so we must poke it directly
	pextrw eax, mm3, 3			; extract highest word (0...3); although word sized,
	or eax, eax					; affects eax, so or eax is safe
	je @F						; jump if equal (it's either 0 or ffff)
	psllq mm2, 10				; multiply divisor by 1024
	psrlq mm1, 10				; divide number by 1024
	dec edi						; choose the next higher unit
	jnz @B

@@:
  movd eax, mm1    				; the remainder
  xor ecx, ecx						; for flag and multiply

  .if edi<6 || eax>=1024
	add ecx, 100
	mul ecx
	sar eax, 10					; divide by 1024
	dec edi
  .endif

  push ecx						; flag decimals
  ifndef FlexByteBuffer
	.data?
	FlexByteBuffer	dd 4 dup (?)
	.code
  endif
  mov esi, offset FlexByteBuffer
  invoke dwtoa, eax, esi
  pop ecx							; pop flag decimals
  .if ecx							; add the dot
	mov edx, [esi+len(esi)-2]	; len returns eax, so we use ecx as accu
	mov cl, "."
	mov [esi+eax-2], cl
	mov [esi+eax-1], edx
  .endif
  lea edi, [t6+4*edi]				; our unit
  invoke lstrcat, esi, edi			; add the xByte unit
  ret
ShowQwMMX endp

dummyPMMX proc
dummyPMMX endp
endif	; end use mmx

;	Mirno, http://www.masm32.com/board/index.php?topic=9585.msg70160#msg70160
;	Take the exponent (bits 30 down to 23)
;	Subtract 127
;	Divide by 10
;	Add 127 to the remainder, and replace the exponent in the original number
;	The result of the division is 0 = bytes, 1 = kilobytes, 2 = megabytes etc.
;	Print the resulting floating point number (it will be in the range of 0 to 1023.999ish), and
;	append some string pointed to by the result of the division.

; The EMMS instruction takes only one clock cycle, but the first floating point instruction after
; an EMMS takes approximately 58 clocks extra, and the first MMX instruction after a floating
; point instruction takes approximately 38 clocks extra.


ShowQw proc uses edi esi ebx pNum:DWORD
LOCAL TmpR4:REAL4
  ffree st(7)		; instead of expensive finit
  mov esi, pNum		; pointer to our 8-byte number
  lea edi, TmpR4
  fild dword ptr [esi]	; convert quad
  fstp dword ptr [edi]	; to real4
  xor ebx, ebx
  mov eax, [edi] 		; our number as real4 - if it's zero, better do nothing
  .if eax
	mov ebx, 1065353216	; 127 shl 23
	sub eax, ebx
	; int 3
	mov ecx, 83886080	; 10 shl 23
	xor edx, edx		; quite useful before a divide ;-)
	div ecx				; divide eax by ecx

	add edx, ebx		; 127 shl 23
	mov ebx, eax		; ebx holds unit
	mov [edi], edx		; replace with new number (exponent in bits 23...30)
	fld dword ptr [edi]	; show Real4 in Olly
	.if ebx
		push 100				; move 100 into the stack
		fimul dword ptr [esp]		; mul ST (0), 100
	.endif
	fistp dword ptr [esp]	; pop result from FPU stack to CPU stack
	pop eax		; correct the CPU stack, and get the result
  .endif

  mov esi, offset FlexByteBuffer
  invoke dwtoa, eax, esi
  mov edx, offset t0				; default is bytes
  .if ebx							; add the dot if it's more than bytes
	mov edx, [esi+len(esi)-2]	; len returns eax, so we use ecx as accu
	mov cl, "."
	mov [esi+eax-2], cl
	mov [esi+eax-1], edx
	lea edx, [t1+4*ebx-4]				; our unit
  .endif
  invoke lstrcat, esi, edx			; add the xByte unit
  ret
ShowQw endp

dummyP proc
dummyP endp

ShowQwBsr proc uses edi esi ebx pNum:DWORD

  ffree st(7)		; instead of expensive finit
  mov esi, pNum		; pointer to our 8-byte number
  fild qword ptr [esi]	; push quad on FPU
  ; int 3

  mov ebx, [esi+4]					; HiDword
  bsr eax, ebx						; get first bit from left
  jne Hs
  mov ebx, [esi]					; LoDword
  bsr eax, ebx						; get first bit from left
  jmp Hx
Hs:
  add eax, 32						; HiDword was set, so add 32
Hx:
  aam								; divide by 10, result in ah, remainder in al
  movzx ecx, ah					; counter
  mov ebx, ecx
  .While ecx
	dec ecx
	fmul compl1024				; multiply with 1/1024
  .Endw
  .if ebx
	push 100					; 2 decimals for anything higher than bytes
	fimul dword ptr [esp]
  .endif
  fistp dword ptr [esp]	; pop result from FPU stack to CPU stack
  pop eax				; our number

  mov esi, offset FlexByteBuffer
  invoke dwtoa, eax, esi
  mov edi, offset t0				; default is bytes
  .if ebx							; add the dot if it's more than bytes
	mov edx, [esi+len(esi)-2]	; len returns eax, so we use ecx as accu
	mov cl, "."
	mov [esi+eax-2], cl
	mov [esi+eax-1], edx
	sal ebx, 2
	sub edi, ebx
  .endif
  invoke lstrcat, esi, edi			; add the xByte unit
  ret
ShowQwBsr endp

dummyBsr proc
dummyBsr endp

end start

OPT_Linker polink
